# solution-center-tracking
Reusable service for tracking Brand Solutions business events

## Usage

1. Install

  ```shell
  npm install solution-center-tracking
  ```

1. Add the module depencency:

  ```javascript
  angular.module('myModule', ['solutioncenter.tracking'])
  ```

1. Inject the service and call `track` with an Event:

  ```javascript
  function myFunc(ScTrackingService) {
    let event = new Event();
    ScTrackingService.track(event);
  }
  ```


## Develop

Clone the repository, then run:
```
npm install
```

### Availble commands

- `npm start`: Run the webpack build and tests in watch mode
- `npm run test`: Run the unit tests and generate a coverage report
  - `open coverage/index.html`: after running unit tests, open the coverage report.
- `npm run test:watch`: Run the unit tests in watch mode
- `npm run build`: Run the webpack build and minify. Generates output in `dist/`.
- `npm run build: watch`: Run the build in watch mode


## Contributing

Before opening a pull request, please ensure that you have included unit tests for your changes
and that all tests are passing.

## License

[MIT](LICENSE)
