/*!
 *  Name: solution-center-tracking
 *  Version: 1.0.2
 *  Homepage: https://github.com/zalando-incubator/solution-center-tracking#readme
 *  License: MIT
 *  @preserve
 */
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var tracking_service_1 = __webpack_require__(1);
	var module = angular.module('solutioncenter.tracking', ['solutioncenter.communicator'])
	    .service('ScTrackingService', tracking_service_1.default);
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = module;


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var event_model_1 = __webpack_require__(2);
	var tracking_error_model_1 = __webpack_require__(3);
	var ScTrackingService = (function () {
	    function ScTrackingService($http, $q, ScEnvironments) {
	        this.$http = $http;
	        this.$q = $q;
	        this.ScEnvironments = ScEnvironments;
	        this.eventUrl = ScEnvironments.getCurrentEnvironment().USER_SERVICE + ScTrackingService.eventEndpoint;
	    }
	    ScTrackingService.eventValid = function (event) {
	        return (!!event.product && !!event.component);
	    };
	    ScTrackingService.prototype.constructUrl = function (eventType) {
	        return "" + this.eventUrl + eventType;
	    };
	    ScTrackingService.prototype.track = function (eventType, e) {
	        if (!eventType) {
	            return this.$q.reject(new tracking_error_model_1.default(tracking_error_model_1.default.NO_EVENT_TYPE));
	        }
	        var event = new event_model_1.Event(e);
	        if (ScTrackingService.eventValid(event)) {
	            return this.$http.post(this.constructUrl(eventType), event);
	        }
	        else {
	            return this.$q.reject(new tracking_error_model_1.default(tracking_error_model_1.default.INVALID_EVENT));
	        }
	    };
	    ScTrackingService.$inject = ['$http', '$q', 'ScEnvironments'];
	    ScTrackingService.eventEndpoint = '/events/business-events/';
	    return ScTrackingService;
	}());
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = ScTrackingService;


/***/ },
/* 2 */
/***/ function(module, exports) {

	"use strict";
	var Event = (function () {
	    function Event(data) {
	        this.product = '';
	        this.component = '';
	        Object.assign(this, data);
	    }
	    return Event;
	}());
	exports.Event = Event;


/***/ },
/* 3 */
/***/ function(module, exports) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var TrackingError = (function (_super) {
	    __extends(TrackingError, _super);
	    function TrackingError(message) {
	        _super.call(this, message);
	        this.message = message;
	        this.name = 'TrackingError';
	    }
	    TrackingError.INVALID_EVENT = 'Invalid event. Missing one or more required parameter: event_name, product, source, component.';
	    TrackingError.NO_EVENT_TYPE = 'No event type was provided.';
	    return TrackingError;
	}(Error));
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = TrackingError;


/***/ }
/******/ ]);