const webpack = require('webpack');
const path = require('path');
const pkg = require('./package.json');
const banner =
  ' Name: ' + pkg.name + '\n' +
  ' Version: ' + pkg.version + '\n' +
  ' Homepage: ' + pkg.homepage + '\n' +
  ' License: ' + pkg.license + '\n' +
  ' @preserve';

module.exports = {
  entry: './src/index.ts',
  output: {
    path: __dirname + '/dist',
    filename: 'solutioncenter.tracking.js'
  },
  resolve: {
    // Add `.ts` and `.tsx` as a resolvable extension.
    extensions: ['', '.webpack.js', '.web.js', '.ts', '.tsx', '.js'],
    alias: {
      'solution-center-communicator': 'solution-center-communicator/src/solutioncenter.communicator.js'
    }
  },
  module: {
    preLoaders: [
      {test: /\.ts$/, loader: 'tslint'}
    ],
    loaders: [
      // all files with a `.ts` or `.tsx` extension will be handled by `ts-loader`
      {test: /\.ts$/, loader: 'ts-loader'}
    ]
  },
  plugins: [
    new webpack.BannerPlugin(banner)
  ]
};
